'****************************************************************************
'
' UKAW Paket   : XP2HTML (CrossPoint PM's to Netscape or Outlook Express
'                         Viewer)
' Version      : 1.39g
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: www.snafu.de/~pbsound
' Last Updates : see directly in the sources
'
' all original sources by Thomas Gohel
'
'****************************************************************************

$INCLUDE "WIN32API.INC"

FUNCTION CopyXP2OE (Quelle$, Ziel$) AS INTEGER

        DIM FileName AS ASCIIZ * 255
        DIM hWnd     AS LONG           

        Filename$ = Ziel$

        'altes CrossPoint-File lschen und falls dieses nicht funktioniert,
        'hlt eine OE-Instanz dieses File bereist offen
        IF LEN(DIR$(Filename$)) > 0 THEN
            IF DeleteFile (Filename$) = %TRUE THEN
                   'File wurde gelscht und kann neu erstellt werden
               ELSE
                   STDOUT "Eine CrossPoint-Instanz von Outlook Express ist bereits aktiv!"
                   BEEP
                   'sinnlos, da Zugriff verweigert werden wird, da File offen
                   WAITKEY$
                   EXIT FUNCTION
             END IF
        END IF

        OPEN Quelle$ FOR BINARY AS #1
        OPEN Ziel$ FOR BINARY AS #2

        DO WHILE NOT EOF(1)
            GET$ #1, 500000, Puffer$
            IF INSTR(1, Puffer$,"Content-Type: multipart") > 0 THEN
                ' eigentlich nicht ntig, da OE auch Inline liegende Multiparts
                ' erkennt, aber korrekt ist korrekt
                REPLACE "Content-Type: text/plain; charset=us-ascii" + CHR$(10) WITH "" IN Puffer$
                REPLACE "Content-Transfer-Encoding: 7bit" + CHR$(10) WITH "" IN Puffer$
            END IF
            'extrem wichtig, da OE bei Unix-Style Zeilenumbrchen reihenweise
            'Dekodierungsfehler erzeugt
            REPLACE CHR$(10) WITH CHR$(13,10) IN Puffer$
            PUT$ #2, Puffer$
        LOOP

        PUT$ #2, CHR$(10)

        CLOSE #1
        CLOSE #2

        ' den OE-Viewer starten
        Result& = ShellExecute(hWnd, "Open", Filename$, "", "", 1)

END FUNCTION

FUNCTION CopyXP2NS (Quelle$, Ziel$) AS INTEGER

        DIM FileName AS ASCIIZ * 255

        Filename$ = Ziel$ + ".snm"

        OPEN Quelle$ FOR BINARY AS #1
        OPEN Ziel$ FOR BINARY AS #2

        SEEK #2, LOF(2)                 ' neue Mail anhngen

        DO WHILE NOT EOF(1)
            GET$ #1, 500000, Puffer$
            IF INSTR(1, Puffer$,"Content-Type: multipart") > 0 THEN
                ' NS erkennt keine Inline liegenden Multiparts, also mu
                ' das Spoolfile berarbeitet werden.
                REPLACE "Content-Type: text/plain; charset=us-ascii" + CHR$(10) WITH "" IN Puffer$
                REPLACE "Content-Transfer-Encoding: 7bit" + CHR$(10) WITH "" IN Puffer$
            END IF
            PUT$ #2, Puffer$
        LOOP

        PUT$ #2, CHR$(10)

        CLOSE #1
        CLOSE #2

        ' Netscape Index-File lschen, damit die Mail ohne Verzgerung
        ' eingelesen wird
        Result& = DeleteFile (Filename$)

END FUNCTION

FUNCTION PBMAIN

        $INCLUDE "UKAW.VER"

        IF COMMAND$ = "" OR INSTR(COMMAND$,"?")>0 THEN
            STDOUT "XP2HTML " + Version$ + "                              (Freeware sources by Thomas Gohel)"
            STDOUT "                                                   compilation by " + Author$
            STDOUT " "
            STDOUT "Usage: XP2HTML"
        END IF

        STDOUT

	Cmd$ = COMMAND$
      
        Quelle$  = PARSE$(Cmd$, " ", 1)
        Ziel$    = PARSE$(Cmd$, " ", 2)	
        Browser$ = PARSE$(Cmd$, " ", 3)
        Browser$ = UCASE$(Browser$)

        IF LEN(Quelle$) = 0 THEN
            STDOUT "$FILE wurde in XP nicht definiert!"
            BEEP
            EXIT FUNCTION
        END IF

        IF LEN(Ziel$) = 0 THEN
            STDOUT "Das zu schreibende RFC-Spoolfile wurde nicht definiert!"
            BEEP
            EXIT FUNCTION
        END IF

        IF LEN(Browser$) = 0 THEN
            STDOUT "Der zu untersttzende Newsreader wurde nicht definiert!"
            BEEP
            EXIT FUNCTION
        END IF

        IF LEN(DIR$("UUZ-311E.EXE")) = 0 THEN
             STDOUT "UUZ v3.11e nicht gefunden"
             BEEP
        END IF


        IF LEN(DIR$(Quelle$)) = 0 THEN
            STDOUT "CrossPoint RFC-Mail: " + Quelle$ + " nicht gefunden!"
        ELSE
            REPLACE "/" WITH "" IN Browser$
            SELECT CASE Browser$
                CASE "OE"
                    i% = CopyXP2OE%(Quelle$, Ziel$)
                CASE "NS"
                    i% = CopyXP2NS%(Quelle$, Ziel$)
                CASE ELSE
                    STDOUT "Undefinierter Browser: " + Browser$
                    BEEP
            END SELECT        
        END IF

END FUNCTION